"use strict";

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

module.exports = function (context) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var Syntax = context.Syntax,
        RuleError = context.RuleError,
        report = context.report,
        getSource = context.getSource;


    var regex = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g; // サロゲートペアの正規表現

    return _defineProperty({}, Syntax.Str, function (node) {
        // "Str" node
        var text = getSource(node); // Get text

        var kanjis = text.match(regex);

        if (!kanjis) {
            return;
        }

        kanjis.forEach(function (kanji, i) {
            var indexOfKanji = text.indexOf(kanjis[i]);

            var ruleError = new RuleError('「' + kanjis[i] + "」はサロゲートペアです。", {
                index: indexOfKanji
            });
            report(node, ruleError);
        });
    });
};
//# sourceMappingURL=index.js.map